unit ADO_1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, ADODB, StdCtrls, Grids, DBGrids, typinfo, wwSpeedButton,
  wwDBNavigator, ExtCtrls, wwclearpanel, ComCtrls, fcStatusBar, FileCtrl,
  Wwdbigrd, Wwdbgrid, Wwdatsrc;

type
  TfrmConnectingToExcelwithADO = class(TForm)
    ADC1: TADOConnection;
    OpenDialog1: TOpenDialog;
    ADOQuery1: TADOQuery;
    DataSource1: TDataSource;
    pg1: TPageControl;
    tsbasic: TTabSheet;
    tsEdit: TTabSheet;
    btnBrowse: TButton;
    Label4: TLabel;
    Edit1: TEdit;
    btnRead: TButton;
    Label5: TLabel;
    tblMemo: TMemo;
    lblTableName: TLabel;
    fldMemo: TMemo;
    wwDBNavigator2: TwwDBNavigator;
    wwNavButton1: TwwNavButton;
    wwNavButton2: TwwNavButton;
    wwNavButton3: TwwNavButton;
    wwNavButton4: TwwNavButton;
    wwNavButton5: TwwNavButton;
    wwNavButton6: TwwNavButton;
    wwNavButton7: TwwNavButton;
    wwNavButton8: TwwNavButton;
    wwNavButton9: TwwNavButton;
    wwNavButton10: TwwNavButton;
    DBGrid2: TDBGrid;
    cbLogon: TCheckBox;
    StatusBar1: TfcStatusBar;
    btnBrowse2: TButton;
    Label1: TLabel;
    Edit2: TEdit;
    btnRead2: TButton;
    Label2: TLabel;
    Label3: TLabel;
    tblMemo2: TMemo;
    fldmemo2: TMemo;
    wwDBNavigator1: TwwDBNavigator;
    wwNavButton11: TwwNavButton;
    wwNavButton12: TwwNavButton;
    wwNavButton13: TwwNavButton;
    wwNavButton14: TwwNavButton;
    wwNavButton15: TwwNavButton;
    wwNavButton16: TwwNavButton;
    wwNavButton17: TwwNavButton;
    wwNavButton18: TwwNavButton;
    wwNavButton19: TwwNavButton;
    wwNavButton20: TwwNavButton;
    DBGrid1: TDBGrid;
    tsTransferData: TTabSheet;
    btnReadAllBooks: TButton;
    DirectoryListBox1: TDirectoryListBox;
    flb1: TFileListBox;
    DriveComboBox1: TDriveComboBox;
    lblHowMany: TLabel;
    Memo1: TMemo;
    SQLcon: TADOConnection;
    Sales_AnalysisTB: TADOTable;
    Sales_AnalysisDS: TwwDataSource;
    wwDBGrid1: TwwDBGrid;
    Sales_AnalysisTBStaff_Name: TStringField;
    Sales_AnalysisTBWeek_Commencing: TDateTimeField;
    Sales_AnalysisTBHours_Worked: TFloatField;
    Sales_AnalysisTBTotal_Sales: TBCDField;
    btnOpenSQL: TButton;
    btnSQLClose: TButton;
    cbHDR: TCheckBox;
    DelExistingRecords: TADOCommand;
    lblRecords: TLabel;
    edtSQLString: TEdit;
    Label6: TLabel;
    btnExecute: TButton;
    procedure btnBrowseClick(Sender: TObject);
    procedure btnReadClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ShowFieldInfo;
    procedure ShowFieldInfo2;
    procedure tblMemoMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnBrowse2Click(Sender: TObject);
    procedure btnRead2Click(Sender: TObject);
    procedure tblMemo2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  procedure ShowExceptions(Sender: TObject; E: Exception);
    procedure flb1Change(Sender: TObject);
    procedure btnReadAllBooksClick(Sender: TObject);
    procedure btnOpenSQLClick(Sender: TObject);
    procedure btnSQLCloseClick(Sender: TObject);
    procedure btnExecuteClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmConnectingToExcelwithADO: TfrmConnectingToExcelwithADO;
  constr, HDRstr : string;
  aFilename, aTblName : string;
  surnames : array[1..40] of string;
  firstnames : array[1..40] of string;
implementation

{$R *.dfm}

//..............................................................................
procedure TfrmConnectingToExcelwithADO.btnBrowseClick(Sender: TObject);
begin
if OpenDialog1.Execute then
  edit1.Text := OpenDialog1.FileName
else
  edit1.text := '';
end;
//..............................................................................
procedure TfrmConnectingToExcelwithADO.btnReadClick(Sender: TObject);
begin

  if cbHDR.Checked then
    HDRstr := 'HDR=Yes;' else HDRStr := 'HDR=No;';

  tblmemo.Lines.Clear;
  aFileName := edit1.Text;
  if aFileName = '' then
    begin
      showmessage('Please browse for an Excel workbook before proceeding');
      exit;
    end;
  if NOT fileexists(aFileName) then
    begin
      showmessage('The file selected does not now exist. Please browse for an Excel workbook before proceeding');
      exit;
    end;

  with ADC1 do
    begin
      if connected then close;
      ConnectionString := '';
      constr := 'Provider=Microsoft.Jet.OLEDB.4.0;' +
                'Data Source=' + aFileName  + ';' +
                'Extended Properties="Excel 8.0;' +
                HDRstr + '"';

      ConnectionString := constr;
      Loginprompt := cbLogon.Checked;
    end;

  try
    ADC1.open;
    ADC1.GetTableNames(tblMemo.Lines);
  except
    showmessage('Unable to open the Excel workbook specified');
    raise;
  end;
end;
//..............................................................................
procedure TfrmConnectingToExcelwithADO.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  if ADC1.Connected then ADC1.close;
end;
//..............................................................................
procedure TfrmConnectingToExcelwithADO.tblMemoMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  //find out where we are and the relevant table name and then find the
  //appropriate field names by scanning rows
  ShowFieldInfo;
end;
//................................................................................................................................................

procedure TfrmConnectingToExcelwithADO.btnExecuteClick(Sender: TObject);
begin
  with ADOQuery1 do
    begin
      if active then close;
      SQL.Clear;
      SQL.Add(edtSQLString.Text);
      open;
    end;
end;
//..............................................................................
procedure TfrmConnectingToExcelwithADO.ShowFieldInfo;
var
  i : integer;
  aFieldType : TFieldType;
  aFieldString, aFieldname : string;
begin
  fldMemo.Clear;
  aTblName := tblMemo.Lines[tblMemo.caretpos.y];
  if atblName = '' then exit;

  edtSQLString.Text := 'SELECT * FROM [' + atblName + ']';
  btnExecute.Click;

  with ADOQuery1 do
    begin
      lblTableName.Caption := 'Field names for table ' + aTblName + ' with ' + IntToStr(ADOQuery1.RecordCount) + ' records';
      for i:= 0 to ADOQuery1.Fields.Count -1 do
        begin
          aFieldType    := ADOQuery1.Fields[i].DataType;
          aFieldString  := GetEnumName(TypeInfo(TFieldType), Integer(aFieldType));
          aFieldname    := ADOQuery1.Fields[i].FieldName;
          fldMemo.lines.add(Format('%d) FieldName: %s FieldType: %s',[i + 1, aFieldName, aFieldString]));
        end;
    end;{with ADOQuery1}
end;
//................................................................................................................................................

procedure TfrmConnectingToExcelwithADO.FormShow(Sender: TObject);
begin
  pg1.ActivePageIndex := 0;
end;
//................................................................................................................................................

procedure TfrmConnectingToExcelwithADO.FormCreate(Sender: TObject);
begin
  cbLogon.Checked := True;
  Application.OnException := ShowExceptions;
end;
//................................................................................................................................................
procedure TfrmConnectingToExcelwithADO.ShowExceptions(Sender: TObject; E: Exception);
begin
  StatusBar1.Panels[1].Text := E.Message;
end;
//................................................................................................................................................
procedure TfrmConnectingToExcelwithADO.btnBrowse2Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
    edit2.Text := OpenDialog1.FileName
  else
    edit2.text := '';
end;
//................................................................................................................................................
procedure TfrmConnectingToExcelwithADO.btnRead2Click(Sender: TObject);
var
  constr : string;
  aFilename : string;
begin
  tblmemo2.Lines.Clear;
  aFileName := edit2.Text;
  if aFileName = '' then
    begin
      showmessage('Please browse for an Excel workbook before proceeding');
      exit;
    end;
  if NOT fileexists(aFileName) then
    begin
      showmessage('The file selected does not now exist. Please browse for an Excel workbook before proceeding');
      exit;
    end;

  with ADC1 do
    begin
      if connected then close;
      ConnectionString := '';
      constr := 'Provider=Microsoft.Jet.OLEDB.4.0;' +
                'Data Source=' + aFileName  + ';' +
                'Extended Properties="Excel 8.0;HDR=Yes;"';

      ConnectionString := constr;
      Loginprompt := False;
    end;
  try

    ADC1.open;
    ADC1.GetTableNames(tblMemo2.Lines);
  except
    showmessage('Unable to open the Excel workbook specified');
    raise;
  end;

end;
//................................................................................................................................................
procedure TfrmConnectingToExcelwithADO.tblMemo2MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ShowFieldInfo2;
end;
//................................................................................................................................................
procedure TfrmConnectingToExcelwithADO.ShowFieldInfo2;
var
  i : integer;
  aFieldType : TFieldType;
  aFieldString, aFieldname : string;
begin
  fldMemo2.Clear;
  aTblName := tblMemo2.Lines[tblMemo2.caretpos.y];
  if atblName = '' then exit;
  with ADOQuery1 do
    begin
      if active then close;
      SQL.Clear;
      SQL.Add('SELECT * FROM [' + aTblName + ']');
      open;
      for i:= 0 to ADOQuery1.Fields.Count -1 do
        begin
          aFieldType    := ADOQuery1.Fields[i].DataType;
          aFieldString  := GetEnumName(TypeInfo(TFieldType), Integer(aFieldType));
          aFieldname    := ADOQuery1.Fields[i].FieldName;
          fldMemo2.lines.add(Format('%d) FieldName: %s FieldType: %s',[i + 1, aFieldName, aFieldString]));

        end;
    end;

end;
//................................................................................................................................................
procedure TfrmConnectingToExcelwithADO.flb1Change(Sender: TObject);
begin
  lblHowMany.Caption := 'The number of files in folder = ' + IntToStr(flb1.Count);
end;
//................................................................................................................................................

procedure TfrmConnectingToExcelwithADO.btnReadAllBooksClick(
  Sender: TObject);
var
  i : integer;
  aFileName, aDirName : string;
  SalesTotal, HrsTotal : double;
begin
//read the workbooks pointed to in the folder

if flb1.Count = 0 then
  begin
    showmessage('Please choose the correct folder before trying to process Excel workbooks');
    exit;
  end;

  if Not Sales_AnalysisTB.active then Sales_AnalysisTB.open;

  sales_AnalysisTB.DisableControls;

  ADC1.LoginPrompt := False;
  aDirName := '';
  aTblName := 'Sales2006';
  for i := 0 to (flb1.Count - 1) do
    begin
      //open the relevant workbook
      aFileName := flb1.Items[i];
      if FileExists(aFileName) then
        begin
           with ADC1 do
              begin
                if connected then close;
                ConnectionString := '';
                constr := 'Provider=Microsoft.Jet.OLEDB.4.0;' +
                          'Data Source=' + aFileName  + ';' +
                          'Extended Properties=Excel 8.0;';

                ConnectionString := constr;
              end;
              memo1.Lines.Add(aFilename);
              with ADOQuery1 do
                begin
                  if active then close;
                  SQL.Clear;
                  SQL.Add('SELECT * FROM [' + aTblName + ']');
                  open;
                  while not eof do
                    begin
                      //add up the sales and hrs worked for each week and insert into Sales_Analysis Table
                      SalesTotal := FieldByName('Mon Sales').asfloat + FieldByName('Tue Sales').asfloat + FieldByName('Wed Sales').asfloat +
                                    FieldByName('Thu Sales').asfloat + FieldByName('Fri Sales').asfloat + FieldByName('Sat Sales').asfloat +
                                    FieldByName('Sun Sales').asfloat;
                      HrsTotal   := FieldByName('Mon Hrs Worked').asfloat + FieldByName('Tue Hrs Worked').asfloat + FieldByName('Wed Hrs Worked').asfloat +
                                    FieldByName('Thu Hrs Worked').asfloat + FieldByName('Fri Hrs Worked').asfloat + FieldByName('Sat Hrs Worked').asfloat +
                                    FieldByName('Sun Hrs Worked').asfloat;
                      with Sales_AnalysisTB do
                        begin
                          insert;
                          FieldByName('Staff_Name').asstring := aFileName;
                          FieldByName('Week_Commencing').asDateTime := ADOQuery1.FieldByName('WC').asDateTime;
                          FieldByName('Hours_Worked').asFloat   := HrsTotal;
                          FieldByName('Total_Sales').asfloat    := SalesTotal;
                          post;
                        end;
                      next;
                    end; {while not eof}
                  close;
                 end;
        end; {if fileexists}

    end; {for loop}
  memo1.Lines.Add('About to perform UpdateBatch on SQL Server');
  Sales_AnalysisTB.UpdateBatch(arAll);
  lblRecords.Caption := 'No of records in database = ' + IntToStr(Sales_analysisTB.Recordcount);

  sales_AnalysisTB.EnableControls;
end;
//................................................................................................................................................

procedure TfrmConnectingToExcelwithADO.btnOpenSQLClick(Sender: TObject);
begin
  with DelExistingRecords do
    begin
      execute;
    end;
  with sales_analysisTB do
    begin
      open;
      lblRecords.Caption := 'No of records in database = ' + IntToStr(Recordcount);
    end;

end;
//................................................................................................................................................

procedure TfrmConnectingToExcelwithADO.btnSQLCloseClick(Sender: TObject);
begin
    sales_analysisTB.Close;
end;
//................................................................................................................................................

end.
